/**
 * 描述：周期季度 单据头表单校验
 */
shr.defineClass("shr.custom.ExamineGradePersonZQJDEdit", shr.framework.Edit, {

    /**
     * 描述:初始化操作
     * 
     * @action
     */
    initalizeDOM: function () {
        var _self = this;
        //周期类型默认周期解除
        $('#periodStatus').shrSelect('setValue', '' + 2);
        shr.custom.ExamineGradePersonZQJDEdit.superClass.initalizeDOM.call(this);
        _self.periodTypeChange();

    },
      /**
     * 启动排序
     */
      startOrderAction(){
        var _self = this;
        var billId = shr.getUrlRequestParam("billId");
        var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.handler.ExamineZQJDEditHandler&method=startOrder";
        $.ajax({
            url: url,
            async: false,
            // data: { periodicQuarterId: periodicQuarterId},
            success: function (response) {
                shr.showInfo({
                    message: "已锁定周期",
                    history: 2
                });
                setTimeout(function() {
                    location.reload();
                }, 2000); // 2000 毫秒即为两秒钟

            }
            , error: function (response) {
                shr.showError({
                    message: response
                });
            }
        });
    },
    /**
     * 组织维护得分表
     */
    performanceScoreOrgAction() {
        //获取周期季度ID
        var billId = shr.getUrlRequestParam("billId");
        this.reloadPage({
			uipk: "PerformanceScore.form",
			examineGradePersonId: billId,
            method: 'edit'
		});	
    },
    /**
     * 锁定周期
     */
    periodLockAction() {
        var _self = this;
        var billId = shr.getUrlRequestParam("billId");
        var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.handler.ExamineZQJDEditHandler&method=periodLock";
        $.ajax({
            url: url,
            async: false,
            data: { billId: billId},
            success: function (response) {
                shr.showInfo({
                    message: "已锁定周期",
                    history: 2
                });
                setTimeout(function() {
                    location.reload();
                }, 2000); // 2000 毫秒即为两秒钟

            }
            , error: function (response) {
                shr.showError({
                    message: response
                });
            }
        });

    },
    /**
     * 解除周期
     */
    periodUnlockAction() {
        var _self = this;
        var billId = shr.getUrlRequestParam("billId");
        var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.handler.ExamineZQJDEditHandler&method=periodUnlock";
        $.ajax({
            url: url,
            async: false,
            data: { billId: billId},
            success: function (response) {
                shr.showInfo({
                    message: "已解除周期",
                    history: 2
                });
                setTimeout(function() {
                    location.reload();
                }, 2000); // 2000 毫秒即为两秒钟
                

            }
            , error: function (response) {
                shr.showError({
                    message: response
                });
            }
        });

    },
    //周期类型事件触发
    periodTypeChange: function () {
        var _self = this;
        $("#periodType").change(function () {
            var periodType = $("#periodType").val();
            if (periodType == "年度") {
                $("#quarter").shrTextField('disable');//或者设为enable
            } else {
                $("#quarter").shrTextField('enable');//或者设为disable
            }
            console.log(periodType);
        })
        var periodType = $("#periodType").val();
        if (periodType == "年度") {
            $("#quarter").shrTextField('disable');//或者设为enable
        } else {
            $("#quarter").shrTextField('enable');//或者设为disable
        }
        if (this.getOperateState().toUpperCase() == 'EDIT') {
            $("#year").shrTextField('disable');//或者设为enable
        }
    },

    /**
     * 保存
     */
    saveAction: function (event) {
        var periodType = $("#periodType").val();
        var year = $("#year").val();
        if (periodType == "年度") {
            var validYear = this.validateYear(year);
            if (!validYear) {
                shr.showWarning({
                    message: '请输入有效年',
                    history: 2

                });
                return;
            }
        } else {
            var quarter = $("#quarter").val();
            var validYearMonth = this.validateYearMonth(year, quarter);
            if (!validYearMonth) {
                shr.showWarning({
                    message: '请输入有效年或季度',
                    history: 2
                });
                return;
            }
        }
        var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.handler.ExamineZQJDEditHandler&method=getExistsYear";
        var year = $("#year").val()
        var periodType = $("#periodType").val()
        var quarter = $("#quarter").val()
        var exists = true;
        $.ajax({
            url: url,
            async: false,
            data: { year: year, periodType: periodType, quarter: quarter },
            success: function (response) {
                exists = response.data
            }
            , error: function (response) {
                shr.showError({
                    message: response
                });
            }
        });

        // if (this.getOperateState().toUpperCase() == 'ADDNEW') {
        //     //校验该年度是否存在
        //     $.ajax({
        //         url: url,
        //         async: false,
        //         data: { year: year,periodType:periodType ,quarter:quarter},
        //         success: function (response) {
        //             exists = response.data
        //         }
        //         , error: function (response) {
        //             shr.showError({
        //                 message: response
        //             });
        //         }
        //     });
        //     if (exists == true) {
        //         shr.showWarning({
        //             message: '已存在该年度或季度'
        //         });
        //         return;
        //     }
        // }
        // var ispt = false;

        //  //编辑校验该年度的季度是否存在
        // var url2 = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.ExamineZQJDEditHandler&method=getExistsMonth";
        //  $.ajax({
        //     url: url2,
        //     async: false,
        //     data: { year: year,periodType:periodType ,quarter:quarter},
        //     success: function (response) {
        //         exists = response.data
        //     }
        //     , error: function (response) {
        //         shr.showError({
        //             message: response
        //         });
        //     }
        // });
        shr.custom.ExamineGradePersonZQJDEdit.superClass.saveAction.call(this);
    },

    /**
     * 校验有效年
     */
    validateYear: function (year) {
        // 验证年份和月份的格式
        var yearPattern = /^\d{4}$/;
        if (!yearPattern.test(year)) {
            return false; // 年份或者月份格式不正确
        }

        // 构建 Date 对象
        var date = new Date(year);

        // 校验日期的有效性
        if (date.getFullYear() !== parseInt(year)) {
            return false; // 日期不在该年月的有效范围内
        }

        return true; // 年有效
    },
    /**
         * 校验是否有效年或季度
         */
    validateYearMonth: function (year, month) {
        // 验证年份和月份的格式
        var yearPattern = /^\d{4}$/;
        var monthPattern = /^[1-4]$/;

        if (!yearPattern.test(year) || !monthPattern.test(month)) {
            return false; // 年份或者月份格式不正确
        }

        // 构建 Date 对象
        var date = new Date(year);

        // 校验日期的有效性
        if (date.getFullYear() !== parseInt(year)) {
            return false; // 日期不在该年月的有效范围内
        }

        return true; // 年月有效
    }
});
